
:- [bheart].                            % consulting the Beating Heart

%:-assert(bheart(debug)).		% to enable b heart debugging

:-hml_load('editor-model.xttml').       % loading up model.

                                        % defining i/o routines
% general i/o
% inkey
io(att_12,ro_trigger,get_character).
% inchar
io(att_8,ro_trigger,read_chars_from_file).
% outchar
io(att_10,wo_trigger,write_chars_to_file).

% editor content output
% chars:
io(att_3,wo_trigger,display_chars).
% cursor
io(att_4,wo_trigger,display_cursor).

% single character input
get_character([Char]):-
	get_single_char(C),
	resolve_character(C,Char),!.

resolve_character(15,"^o").
resolve_character(19,"^s").
resolve_character(17,"^q").

resolve_character(10,"left").
resolve_character(11,"right").
resolve_character(127,"backspace").

resolve_character(C,[C]).

% editor content output

display_chars(X,X) :-
	write('on screen->>>:'),maplist(putvalues,X),nl.

display_cursor([X],[X]):-
	write('cursor at->>>:'), write(X),nl.
	
% file i/o

read_chars_from_file(["T","h","i","s"," ","i","s"," ","r","e","a","d"," ","i","n","."]).
write_chars_to_file(X,X):-
	write('file output->>>:'),maplist(putvalues,X),nl.

putvalues([]):-
	 put(' ').
putvalues([13]):-
	nl.
putvalues([X]):-
	put(X).

                                        % starting the inference process
:-run_xtt_single(xtt_0).
